// FILENAME:	TDM_COTE_Moonstrike.cs
//
// Author:  -={Green Demon}=-   Modified: 10/2009
//-------------------------------------------------------------------

$missionName = "TDM_COTE_Moonstrike";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
 $server::TeamPlay = false;
 $server::AllowDeathmatch = true;
 $server::AllowTeamPlay = true;	

// what can the client choose for a team
 $server::AllowTeamRed = true;
 $server::AllowTeamBlue = true;
 $server::AllowTeamYellow = false;
 $server::AllowTeamPurple = false;

// what can the server admin choose for available teams
 $server::disableTeamRed = false;
 $server::disableTeamBlue = false;
 $server::disableTeamYellow = true;
 $server::disableTeamPurple = true;
}


function onMissionStart()
{
 $BlueHeal=Yes;
 $RedHeal=Yes;
 $ST="";

 schedule("processPods();", 60);
}


function onMissionLoad()
{
 setGameInfo("<F2>GAME TYPE:<F0> DeathMatch or Team DeathMatch\n\n<F2>MISSION:<F0>  TDM_COTE_Moonstrike\n\nWelcome to Team DeathMatch COTE Moonstrike. Scan the ball on your team's heal pad to set NO ENEMY Repairing/Reloading in your pads. Only your team will know if its set to kill till someone dies. Once set, its set for the remainder of the game."); 
}


function player::onAdd(%player)
{
 say(%player,0,"<JC>Welcome to TDM COTE Moonstrike\nThis is a MERCENARIES SERVER - Visit the Mercenaries Site at (http://starsiege1.proboards.com) - Get Maps, Skins, Patches, and Updates there.");
 if(strAlign(1,left,getname(%player))=="/")
   {
    say(0,0,"<f5>"@getname(%player)@" joined the game","alarm2.wav");
    messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
   }
}


function player::onRemove(%player)
{
 if(strAlign(1,left,getname(%player))=="/")
   {
    say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
   }
}


function vehicle::onadd(%vehicleId)
{
 if($ST=="") $ST=getcurrenttime();
 %player=playerManager::vehicleIdToPlayerNum(%vehicleId);         
 %i=$server::TimeLimit*60+$ST-getcurrentTime();
 setHudTimer(%i,-1,"Map Time Left",1,%player);

}


//--------------------{Set Pads To No Enemy Heal}------------------------

function NoRed::structure::onScan(%this,%attacker)
{
 if(getTeam(%attacker)==*IDSTR_TEAM_BLUE&&$BlueHeal==Yes&&$server::TeamPlay==true)
   {
    $BlueHeal=No;      
    teamTrans("<F1>Blue's<F2> Pads set to Kill <F5>Reds<F2> on Shutdown",*IDSTR_TEAM_BLUE);
    teamTrans("bptslct.WAV",*IDSTR_TEAM_BLUE);
   }
}


function NoBlue::structure::onScan(%this,%attacker)
{
 if(getTeam(%attacker)==*IDSTR_TEAM_RED&&$RedHeal==Yes&&$server::TeamPlay==true)
   {
    $RedHeal=No;      
    teamTrans("<F5>Red's<F2> Pads set to Kill <F1>Blues<F2> on Shutdown",*IDSTR_TEAM_RED);
    teamTrans("bptslct.WAV",*IDSTR_TEAM_RED);
   }
}


//-----------------------{Heal Pad Checks}----------------------------

function blueheal::trigger::onContact(%trigger,%vehicleId)
{
 if(isshutdown(%vehicleId)) 
   {
    if(getTeam(%vehicleId)==*IDSTR_TEAM_RED&&$BlueHeal==No) 
      {    
       healObject(%vehicleId,-50000);say(%player,0,"<F2>Stay OUT of <F1>Blue's<F2> Heal! <F5>"@getHudName(%vehicleId)@" !","F2_DM_thatllteach.wav");
      }
    else healObject(%vehicleId,400); 
   }
}


function blueammo::trigger::onContact(%trigger,%vehicleId)
{
 if(isshutdown(%vehicleId)) 
   {
    if(getTeam(%vehicleId)==*IDSTR_TEAM_RED&&$BlueHeal==No)
      {    
       healObject(%vehicleId,-50000);say(%player,0,"<F2>Stay OUT of <F1>Blue's<F2> Reload! <F5>"@getHudName(%vehicleId)@" !","F2_DM_thatllteach.wav");
      }
    else reloadObject(%vehicleId,50); 
   }
}       


function redheal::trigger::onContact(%trigger,%vehicleId)
{
 if(isshutdown(%vehicleId)) 
   {
    if(getTeam(%vehicleId)==*IDSTR_TEAM_BLUE&&$RedHeal==No)
      {    
       healObject(%vehicleId,-50000);say(%player,0,"<F2>Stay OUT of <F5>Red's<F2> Heal! <F1>"@getHudName(%vehicleId)@" !","F2_DM_thatllteach.wav");
      }
    else healObject(%vehicleId,400); 
   }
}


function redammo::trigger::onContact(%trigger,%vehicleId)
{
 if(isshutdown(%vehicleId)) 
   {
    if(getTeam(%vehicleId)==*IDSTR_TEAM_BLUE&&$RedHeal==No)
      {    
       healObject(%vehicleId,-50000);say(%player,0,"<F2>Stay OUT of <F5>Red's<F2> Reload! <F1>"@getHudName(%vehicleId)@" !","F2_DM_thatllteach.wav");
      }
    else reloadObject(%vehicleId,50); 
   }
}


//------------------{Team Only Transmissions}-------------------------

function teamTrans(%text,%team)
{
 %count=playerManager::getPlayerCount();
 for(%i=0;%i<%count;%i++)
    {
     %player=playerManager::getPlayerNum(%i);
     if(getTeam(%player)==%team)
       {
        say(%player,%player,%text);
       }
    }
}


// Water Tower splash functionality
function structure::onDestroyed(%this,%attackerId)
{
 if(%this==getObjectId("MissionGroup\\BlueBase\\WaterTower1"))
   {
    setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash1"),true);
    playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash1"),0,true);
   }
 else if(%this==getObjectId("MissionGroup\\BlueBase\\WaterTower2"))
   {
    setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash2"),true);
    playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash2"),0,true);
   }
 else if(%this==getObjectId("MissionGroup\\BlueBase\\WaterTower3"))
   {
    setShapeVisibility(getObjectId("MissionGroup\\BlueBase\\Splash3"),true);
    playAnimSequence(getObjectId("MissionGroup\\BlueBase\\Splash3"),0,true);
   }
}


function onmissionend()
{
 flushConsoleScheduler();
 deleteVariables($BlueHeal);
 deleteVariables($RedHeal);
 deleteVariables($ST);
 deleteFunctions("onMissionStart");
 deleteFunctions("onMissionLoad");
 deleteFunctions("player::onAdd");
 deleteFunctions("player::onRemove");
 deleteFunctions("vehicle::onadd"); 
 deleteFunctions("NoBlue::structure::onScan");
 deleteFunctions("NoRed::structure::onScan");
 deleteFunctions("blueheal::trigger::onContact");
 deleteFunctions("blueammo::trigger::onContact");
 deleteFunctions("redheal::trigger::onContact");
 deleteFunctions("redammo::trigger::onContact");
 deleteFunctions("teamTrans");
 deleteFunctions("structure::onDestroyed");
 missionEndConditionMet();   
}