// FILENAME: TDM_City_In_Ruins+.cs
//
// AUTHOR:   *~Milliardo~*
//------------------------------------------------------------------------------
// Modified By:  -={Green Demon}=-  Date: 6/09/10  
// Added: Stealth detection, No enemy pad use switches.
// Added: Map Time Left, ruined ore drill rig area added.
// Added: Center building doubled & rotated, Zen Pads.
// Fixed: Hump at Twin Towers Monument.
//------------------------------------------------------------------------------


$missionName = "TDM_City_In_Ruins+";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");


function setDefaultMissionOptions()
{
 $server::TeamPlay = True;
 $server::AllowDeathmatch = False;
 $server::AllowTeamPlay = True;	
	
 $server::AllowTeamRed = true;
 $server::AllowTeamBlue = true;
 $server::AllowTeamYellow = false;
 $server::AllowTeamPurple = false;

 $server::disableTeamRed = false;
 $server::disableTeamBlue = false;
 $server::disableTeamYellow = true;
 $server::disableTeamPurple = true;
}


function onMissionStart()
{
 $BlueHeal=Yes;
 $RedHeal=Yes;
 $ST="";
}


function player::onAdd(%player)
{
 say(%player,0,"<JC>Welcome to TDM City In Ruins+\nThis is a MERCENARIES SERVER - Visit the Mercenaries Site at (http://starsiege1.proboards.com) - Get Maps, Skins, Patches, and Updates there.");
 if(strAlign(1,left,getname(%player))=="/")
   {
    say(0,0,"<f5>"@getname(%player)@" joined the game","alarm2.wav");
    messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
   }
}


function player::onRemove(%player)
{
 if(strAlign(1,left,getname(%player))=="/")
   {
    say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
   }
}


function vehicle::onadd(%vehicleId)
{
 if($ST=="") $ST=getcurrenttime();
 %player=playerManager::vehicleIdToPlayerNum(%vehicleId);         
 %i=$server::TimeLimit*60+$ST-getcurrentTime();
 setHudTimer(%i,-1,"Map Time Left",1,%player);

}


//--------------------{Set Pads To No Enemy Heal}------------------------

function NoRed::structure::onScan(%this,%attacker)
{
 if(getTeam(%attacker)==*IDSTR_TEAM_BLUE&&$BlueHeal==Yes&&$server::TeamPlay==true)
   {
    $BlueHeal=No;      
    teamTrans("<F1>Blue's<F2> Pads set to Kill <F5>Reds<F2> on Shutdown",*IDSTR_TEAM_BLUE);
    teamTrans("bptslct.WAV",*IDSTR_TEAM_BLUE);
   }
}


function NoBlue::structure::onScan(%this,%attacker)
{
 if(getTeam(%attacker)==*IDSTR_TEAM_RED&&$RedHeal==Yes&&$server::TeamPlay==true)
   {
    $RedHeal=No;      
    teamTrans("<F5>Red's<F2> Pads set to Kill <F1>Blues<F2> on Shutdown",*IDSTR_TEAM_RED);
    teamTrans("bptslct.WAV",*IDSTR_TEAM_RED);
   }
}


//-----------------------{Heal Pad Checks}----------------------------

function blueheal::trigger::onContact(%trigger,%vehicleId)
{
 if(isshutdown(%vehicleId)) 
   {
    if(getTeam(%vehicleId)==*IDSTR_TEAM_RED&&$BlueHeal==No) 
      {    
       healObject(%vehicleId,-50000);say(%player,0,"<F2>Stay OUT of <F1>Blue's<F2> Heal! <F5>"@getHudName(%vehicleId)@" !","F2_DM_thatllteach.wav");
      }
    else healObject(%vehicleId,300); 
   }
}


function blueammo::trigger::onContact(%trigger,%vehicleId)
{
 if(isshutdown(%vehicleId)) 
   {
    if(getTeam(%vehicleId)==*IDSTR_TEAM_RED&&$BlueHeal==No)
      {    
       healObject(%vehicleId,-50000);say(%player,0,"<F2>Stay OUT of <F1>Blue's<F2> Reload! <F5>"@getHudName(%vehicleId)@" !","F2_DM_thatllteach.wav");
      }
    else reloadObject(%vehicleId,50); 
   }
}       


function redheal::trigger::onContact(%trigger,%vehicleId)
{
 if(isshutdown(%vehicleId)) 
   {
    if(getTeam(%vehicleId)==*IDSTR_TEAM_BLUE&&$RedHeal==No)
      {    
       healObject(%vehicleId,-50000);say(%player,0,"<F2>Stay OUT of <F5>Red's<F2> Heal! <F1>"@getHudName(%vehicleId)@" !","F2_DM_thatllteach.wav");
      }
    else healObject(%vehicleId,300); 
   }
}


function redammo::trigger::onContact(%trigger,%vehicleId)
{
 if(isshutdown(%vehicleId)) 
   {
    if(getTeam(%vehicleId)==*IDSTR_TEAM_BLUE&&$RedHeal==No)
      {    
       healObject(%vehicleId,-50000);say(%player,0,"<F2>Stay OUT of <F5>Red's<F2> Reload! <F1>"@getHudName(%vehicleId)@" !","F2_DM_thatllteach.wav");
      }
    else reloadObject(%vehicleId,50); 
   }
}


//--------------------{Team Only Transmissions}-----------------------

function teamTrans(%text,%team)
{
 %count=playerManager::getPlayerCount();
 for(%i=0;%i<%count;%i++)
    {
     %player=playerManager::getPlayerNum(%i);
     if(getTeam(%player)==%team)
       {
        say(%player,%player,%text);
       }
    }
}


//---------------------------{Zen Pads}-------------------------------

function ZenAll::trigger::onContact(%this,%object)
{
 Zen::work(%this,%object,300,25,0,true);// 300% health 25% reload 
}


function onmissionend()
{
 flushConsoleScheduler();
 deleteVariables($BlueHeal);
 deleteVariables($RedHeal);
 deleteVariables($ST);

 deleteFunctions("onMissionStart");
 deleteFunctions("onMissionLoad");
 deleteFunctions("player::onAdd");
 deleteFunctions("player::onRemove");
 deleteFunctions("vehicle::onadd"); 
 deleteFunctions("NoBlue::structure::onScan");
 deleteFunctions("NoRed::structure::onScan");
 deleteFunctions("blueheal::trigger::onContact");
 deleteFunctions("blueammo::trigger::onContact");
 deleteFunctions("redheal::trigger::onContact");
 deleteFunctions("redammo::trigger::onContact");
 deleteFunctions("teamTrans");
 deleteFunctions("ZenAll::trigger::onContact");

 missionEndConditionMet();
} 