// FILENAME:	TDM_New_Cairo.cs
//
// AUTHOR:  -={Green Demon}=-   Created: 10/27/2011
//-------------------------------------------------------------------

$missionName = "TDM_Venus_Mounds";

$server::HudMapViewOffsetX=2600;
$server::HudMapViewOffsetY=5000;

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");


function setDefaultMissionOptions()
{
 $server::TeamPlay = true;
 $server::AllowDeathmatch = true;
 $server::AllowTeamPlay = true;	

 $server::AllowTeamRed = true;
 $server::AllowTeamBlue = true;
 $server::AllowTeamYellow = false;
 $server::AllowTeamPurple = false;

 $server::disableTeamRed = false;
 $server::disableTeamBlue = false;
 $server::disableTeamYellow = true;
 $server::disableTeamPurple = true;
}


function onMissionStart()
{
 $BlueHeal=Yes;
 $RedHeal=Yes;
 $ST="";
 venusSounds();

 //Radar 
 createAmbientSoundSource("Missiongroup\\Misc\\Radar",0,0,0);
 addToAmbientSoundSource("Missiongroup\\Misc\\Radar","sfx_radar_station.wav", IDPRF_FLYER_LOOPING);

 // Mine Train Engine
 createAmbientSoundSource("Missiongroup\\Misc\\Mine Train 1\\Engine1",0,0,0);
 addToAmbientSoundSource("Missiongroup\\Misc\\Mine Train 1\\Engine1","sfx_industrial.wav", IDPRF_FLYER_LOOPING);

 // Water Towers at Red Base
 createAmbientSoundSource("Missiongroup\\Misc\\Water1",0,0,0);
 addToAmbientSoundSource("Missiongroup\\Misc\\Water1","sfx_swamp.WAV", IDPRF_FLYER_LOOPING);

 //Drill 1 @ Red Base
 createAmbientSoundSource("Missiongroup\\Misc\\Drill Rig 1\\Drill 1",0,0,0);
 addToAmbientSoundSource("Missiongroup\\Misc\\Drill Rig 1\\Drill 1","sfx_machine1.wav", IDPRF_FLYER_LOOPING);

 //Drill 2 @ Blue Base
 createAmbientSoundSource("Missiongroup\\Misc\\Drill Rig 2\\Drill 2",0,0,0);
 addToAmbientSoundSource("Missiongroup\\Misc\\Drill Rig 2\\Drill 2","sfx_machine1.wav", IDPRF_FLYER_LOOPING);

 //Crane 2 @ Blue Base
 createAmbientSoundSource("Missiongroup\\Misc\\Drill Rig 2\\Crane 2",0,0,0);
 addToAmbientSoundSource("Missiongroup\\Misc\\Drill Rig 2\\Crane 2","sfx_machine3.wav", IDPRF_FLYER_LOOPING);
}


function player::onAdd(%player)
{
 say(%player,0,"<JC>Welcome to "@$missionName@"\nThis is a MERCENARIES SERVER - Visit the Mercenaries Site at (http://starsiege1.proboards.com) - Get Maps, Skins, Patches, and Updates there.");
 if(strAlign(1,left,getname(%player))=="/")
   {
    say(0,0,"<f5>"@getname(%player)@" joined the game","alarm2.wav");
    messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
   }
}


function player::onRemove(%player)
{
 if(strAlign(1,left,getname(%player))=="/") say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
}


function vehicle::onadd(%vehicleId)
{
 if($ST=="") $ST=getcurrenttime();
 %player=playerManager::vehicleIdToPlayerNum(%vehicleId);         
 %i=$server::TimeLimit*60+$ST-getcurrentTime();
 setHudTimer(%i,-1,"Map Time Left",1,%player);
}


//--------------------{Set Pads To No Enemy Heal}--------------------

function NoRed::structure::onScan(%this,%vehicleId)
{
 if(getTeam(%vehicleId)==*IDSTR_TEAM_BLUE&&$BlueHeal==Yes&&$server::TeamPlay==true)
   {
    $BlueHeal=No;teamTrans("<F1>Blue's<F2> Pads set to Kill <F5>Reds<F2> on Shutdown",*IDSTR_TEAM_BLUE,"bptslct.WAV");
   }
}


function NoBlue::structure::onScan(%this,%vehicleId)
{
 if(getTeam(%vehicleId)==*IDSTR_TEAM_RED&&$RedHeal==Yes&&$server::TeamPlay==true)
   {
    $RedHeal=No;teamTrans("<F5>Red's<F2> Pads set to Kill <F1>Blues<F2> on Shutdown",*IDSTR_TEAM_RED,"bptslct.WAV");
   }
}


//---------------------{Heal Pad Checks}-----------------------------

function blueheal::trigger::onContact(%this,%object)
{
 if(isshutdown(%object)) 
   {
    if(getTeam(%object)==*IDSTR_TEAM_RED&&$BlueHeal==No) 
      {    
       %n="<F1>Blue";%i="Heal";PadMsg(%object,%n,%i);
      }
    healObject(%object,300); 
   }
}


function blueammo::trigger::onContact(%this,%object)
{
 if(isshutdown(%object)) 
   {
    if(getTeam(%object)==*IDSTR_TEAM_RED&&$BlueHeal==No)
      {    
       %n="<F1>Blue";%i="Reload";PadMsg(%object,%n,%i);
      }
    reloadObject(%object,50); 
   }
}       


function redheal::trigger::onContact(%this,%object)
{
 if(isshutdown(%object)) 
   {
    if(getTeam(%object)==*IDSTR_TEAM_BLUE&&$RedHeal==No)
      {    
       %n="<F5>Red";%i="Heal";PadMsg(%object,%n,%i);
      }
    healObject(%object,300); 
   }
}


function redammo::trigger::onContact(%this,%object)
{
 if(isshutdown(%object)) 
   {
    if(getTeam(%object)==*IDSTR_TEAM_BLUE&&$RedHeal==No)
      {    
       %n="<F5>Red";%i="Reload";PadMsg(%object,%n,%i);
      }
    reloadObject(%object,50); 
   }
}


function PadMsg(%object,%n,%i)
{
 healObject(%object,-50000);say(0,5,"<F4>Stay OUT of "@%n@"'s "@%i@"! <F4>"@getHudName(%object)@" !","F2_DM_thatllteach.wav");
}


//--------------------{Team Only Transmissions}---------------------

function teamTrans(%msg,%team,%n)
{
 for(%i=0;%i<playerManager::getPlayerCount();%i++)
    {
     %player=playerManager::getPlayerNum(%i);if(getTeam(%player)==%team) say(%player,%i,%msg,%n);
    }
}


//----------------------------{Big X}--------------------------------

function BigX::structure::onDestroyed(%this,%player)
{
 stopAmbientSoundSource(%this);%EX=newobject("XP",staticshape,"fx_exp_podT.DTS");
 schedule("playanimsequence("@%Ex@",0,1);",0.1);
 setPosition(%EX,getPosition(%this,x),getPosition(%this,y),getPosition(%this,z));
 damageArea(%this,0,0,0,150,10000);say(0,3,"sfx_reactor_xplo.WAV");
 schedule("deleteObject("@%EX@");",1.6);
}


//---------------------------{Zen Pads}-------------------------------

function ZenAll::trigger::onContact(%this,%object)
{
 Zen::work(%this,%object,400,25,0,true);// 400% health 25% reload 
}


function onmissionend()
{
 stopAmbientSoundSource("Missiongroup\\Misc\\Radar");
 stopAmbientSoundSource("Missiongroup\\Misc\\Mine Train 1\\Engine1");
 stopAmbientSoundSource("Missiongroup\\Misc\\Water1");
 stopAmbientSoundSource("Missiongroup\\Misc\\Drill Rig 1\\Drill 1");
 stopAmbientSoundSource("Missiongroup\\Misc\\Drill Rig 2\\Drill 2");
 stopAmbientSoundSource("Missiongroup\\Misc\\Drill Rig 2\\Crane 2");

 flushConsoleScheduler();
 deleteVariables("$server::HudMapViewOffset*");
 deleteVariables("$BlueHeal");
 deleteVariables("$RedHeal");
 deleteVariables("$ST");

 deleteFunctions("onMissionStart");
 deleteFunctions("onMissionLoad");
 deleteFunctions("player::onAdd");
 deleteFunctions("player::onRemove");
 deleteFunctions("vehicle::onadd");
 deleteFunctions("NoBlue*");
 deleteFunctions("NoRed*");
 deleteFunctions("blue*");
 deleteFunctions("redheal*");
 deleteFunctions("redammo*");
 deleteFunctions("PadMsg");
 deleteFunctions("teamTrans");
 deleteFunctions("BigX"); 
 deleteFunctions("ZenAll*");

 missionEndConditionMet();
} 